]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
tests/smime: consistently quote $GNUPGHOME
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For emacsclient
108 unset ALTERNATE_EDITOR
109
110 add_gnupg_home ()
111 {
112     local output
113     [ -d ${GNUPGHOME} ] && return
114     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
115     at_exit_function _gnupg_exit
116     mkdir -m 0700 "$GNUPGHOME"
117     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
118     test_debug "cat $GNUPGHOME/import.log"
119     if (gpg --quick-random --version >/dev/null 2>&1) ; then
120         echo quick-random >> "$GNUPGHOME"/gpg.conf
121     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
122         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
123     fi
124     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
125
126     # Change this if we ship a new test key
127     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
128     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
129     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
130 }
131
132 add_gpgsm_home ()
133 {
134     local fpr
135     [ -d "$GNUPGHOME" ] && return
136     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
137     at_exit_function _gnupg_exit
138     mkdir -m 0700 "$GNUPGHOME"
139     gpgsm --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/test.crt >"$GNUPGHOME"/import.log 2>&1
140     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
141     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
142     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
143     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
144     test_debug "cat $GNUPGHOME/import.log"
145 }
146
147 # Each test should start with something like this, after copyright notices:
148 #
149 # test_description='Description of this test...
150 # This test checks if command xyzzy does the right thing...
151 # '
152 # . ./test-lib.sh || exit 1
153
154 color=maybe
155
156 while test "$#" -ne 0
157 do
158         case "$1" in
159         -d|--debug)
160                 debug=t; shift ;;
161         -i|--immediate)
162                 immediate=t; shift ;;
163         -h|--help)
164                 help=t; shift ;;
165         -v|--verbose)
166                 verbose=t; shift ;;
167         -q|--quiet)
168                 quiet=t; shift ;;
169         --with-dashes)
170                 with_dashes=t; shift ;;
171         --no-color)
172                 color=; shift ;;
173         --no-python)
174                 # noop now...
175                 shift ;;
176         --valgrind)
177                 valgrind=t; verbose=t; shift ;;
178         --tee)
179                 shift ;; # was handled already
180         *)
181                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
182         esac
183 done
184
185 if test -n "$debug"; then
186     print_subtest () {
187         printf " %-4s" "[$((test_count - 1))]"
188     }
189 else
190     print_subtest () {
191         true
192     }
193 fi
194
195 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
196
197 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
198                 TERM=$ORIGINAL_TERM &&
199                 export TERM &&
200                 tput bold
201                 tput setaf
202                 tput sgr0
203         ) >/dev/null 2>&1
204 then
205         color=t
206 else
207         color=
208 fi
209
210 if test -n "$color"; then
211         say_color () {
212                 (
213                 TERM=$ORIGINAL_TERM
214                 export TERM
215                 case "$1" in
216                         error) tput bold; tput setaf 1;; # bold red
217                         skip)  tput bold; tput setaf 2;; # bold green
218                         pass)  tput setaf 2;;            # green
219                         info)  tput setaf 3;;            # brown
220                         *) test -n "$quiet" && return;;
221                 esac
222                 shift
223                 printf " "
224                 printf "$@"
225                 tput sgr0
226                 print_subtest
227                 )
228         }
229 else
230         say_color() {
231                 test -z "$1" && test -n "$quiet" && return
232                 shift
233                 printf " "
234                 printf "$@"
235                 print_subtest
236         }
237 fi
238
239 error () {
240         say_color error "error: $*\n"
241         GIT_EXIT_OK=t
242         exit 1
243 }
244
245 say () {
246         say_color info "$*"
247 }
248
249 test "${test_description}" != "" ||
250 error "Test script did not set test_description."
251
252 if test "$help" = "t"
253 then
254         echo "Tests ${test_description}"
255         exit 0
256 fi
257
258 test_description_printed=
259 print_test_description ()
260 {
261         test -z "$test_description_printed" || return 0
262         echo
263         echo $this_test: "Testing ${test_description}"
264         test_description_printed=1
265 }
266 if [ -z "$NOTMUCH_TEST_QUIET" ]
267 then
268         print_test_description
269 fi
270
271 test_failure=0
272 test_count=0
273 test_fixed=0
274 test_broken=0
275 test_success=0
276
277 declare -a _exit_functions=()
278
279 at_exit_function () {
280         _exit_functions=($1 ${_exit_functions[@]/$1})
281 }
282
283 rm_exit_function () {
284         _exit_functions=(${_exit_functions[@]/$1})
285 }
286
287 _exit_common () {
288         code=$?
289         trap - EXIT
290         set +ex
291         for _fn in ${_exit_functions[@]}; do $_fn; done
292         rm -rf "$TEST_TMPDIR"
293 }
294
295 trap_exit () {
296         _exit_common
297         if test -n "$GIT_EXIT_OK"
298         then
299                 exit $code
300         else
301                 exec >&6
302                 say_color error '%-6s' FATAL
303                 echo " $test_subtest_name"
304                 echo
305                 echo "Unexpected exit while executing $0. Exit code $code."
306                 exit 1
307         fi
308 }
309
310 trap_signal () {
311         _exit_common
312         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
313         exit $code
314 }
315
316 die () {
317         _exit_common
318         exec >&6
319         say_color error '%-6s' FATAL
320         echo " $*"
321         echo
322         echo "Unexpected exit while executing $0."
323         exit 1
324 }
325
326 GIT_EXIT_OK=
327 # Note: TEST_TMPDIR *NOT* exported!
328 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
329 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
330 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
331 trap 'trap_exit' EXIT
332 trap 'trap_signal' HUP INT TERM
333
334 # Deliver a message with emacs and add it to the database
335 #
336 # Uses emacs to generate and deliver a message to the mail store.
337 # Accepts arbitrary extra emacs/elisp functions to modify the message
338 # before sending, which is useful to doing things like attaching files
339 # to the message and encrypting/signing.
340 emacs_deliver_message ()
341 {
342     local subject="$1"
343     local body="$2"
344     shift 2
345     # before we can send a message, we have to prepare the FCC maildir
346     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
347     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
348     local smtp_dummy_pid= smtp_dummy_port=
349     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
350     test -n "$smtp_dummy_pid" || return 1
351     test -n "$smtp_dummy_port" || return 1
352
353     test_emacs \
354         "(let ((message-send-mail-function 'message-smtpmail-send-it)
355                (mail-host-address \"example.com\")
356                (smtpmail-smtp-server \"localhost\")
357                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
358            (notmuch-mua-mail)
359            (message-goto-to)
360            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
361            (message-goto-subject)
362            (insert \"${subject}\")
363            (message-goto-body)
364            (insert \"${body}\")
365            $*
366            (notmuch-mua-send-and-exit))"
367
368     # In case message was sent properly, client waits for confirmation
369     # before exiting and resuming control here; therefore making sure
370     # that server exits by sending (KILL) signal to it is safe.
371     kill -9 $smtp_dummy_pid
372     notmuch new >/dev/null
373 }
374
375 # Pretend to deliver a message with emacs. Really save it to a file
376 # and add it to the database
377 #
378 # Uses emacs to generate and deliver a message to the mail store.
379 # Accepts arbitrary extra emacs/elisp functions to modify the message
380 # before sending, which is useful to doing things like attaching files
381 # to the message and encrypting/signing.
382 #
383 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
384 # at the head of the argument list, they are sent directly to "notmuch
385 # new" after message delivery
386 emacs_fcc_message ()
387 {
388     local nmn_args=''
389     while [[ "$1" =~ ^-- ]]; do
390         nmn_args="$nmn_args $1"
391         shift
392     done
393     local subject="$1"
394     local body="$2"
395     shift 2
396     # before we can send a message, we have to prepare the FCC maildir
397     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
398
399     test_emacs \
400         "(let ((message-send-mail-function (lambda () t))
401                (mail-host-address \"example.com\"))
402            (notmuch-mua-mail)
403            (message-goto-to)
404            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
405            (message-goto-subject)
406            (insert \"${subject}\")
407            (message-goto-body)
408            (insert \"${body}\")
409            $*
410            (notmuch-mua-send-and-exit))" || return 1
411     notmuch new $nmn_args >/dev/null
412 }
413
414 # Add an existing, fixed corpus of email to the database.
415 #
416 # $1 is the corpus dir under corpora to add, using "default" if unset.
417 #
418 # The default corpus is based on about 50 messages from early in the
419 # history of the notmuch mailing list, which allows for reliably
420 # testing commands that need to operate on a not-totally-trivial
421 # number of messages.
422 add_email_corpus ()
423 {
424     corpus=${1:-default}
425
426     rm -rf ${MAIL_DIR}
427     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
428     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
429 }
430
431 test_begin_subtest ()
432 {
433     if [ -n "$inside_subtest" ]; then
434         exec 1>&6 2>&7          # Restore stdout and stderr
435         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
436     fi
437     test_subtest_name="$1"
438     test_reset_state_
439     # Redirect test output to the previously prepared file descriptors
440     # 3 and 4 (see below)
441     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
442     exec >&3 2>&4
443     inside_subtest=t
444 }
445
446 # Pass test if two arguments match
447 #
448 # Note: Unlike all other test_expect_* functions, this function does
449 # not accept a test name. Instead, the caller should call
450 # test_begin_subtest before calling this function in order to set the
451 # name.
452 test_expect_equal ()
453 {
454         exec 1>&6 2>&7          # Restore stdout and stderr
455         if [ -z "$inside_subtest" ]; then
456                 error "bug in the test script: test_expect_equal without test_begin_subtest"
457         fi
458         inside_subtest=
459         test "$#" = 2 ||
460         error "bug in the test script: not 2 parameters to test_expect_equal"
461
462         output="$1"
463         expected="$2"
464         if ! test_skip "$test_subtest_name"
465         then
466                 if [ "$output" = "$expected" ]; then
467                         test_ok_
468                 else
469                         testname=$this_test.$test_count
470                         echo "$expected" > $testname.expected
471                         echo "$output" > $testname.output
472                         test_failure_ "$(diff -u $testname.expected $testname.output)"
473                 fi
474     fi
475 }
476
477 # Like test_expect_equal, but takes two filenames.
478 test_expect_equal_file ()
479 {
480         exec 1>&6 2>&7          # Restore stdout and stderr
481         if [ -z "$inside_subtest" ]; then
482                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
483         fi
484         inside_subtest=
485         test "$#" = 2 ||
486         error "bug in the test script: not 2 parameters to test_expect_equal_file"
487
488         file1="$1"
489         file2="$2"
490         if ! test_skip "$test_subtest_name"
491         then
492                 if diff -q "$file1" "$file2" >/dev/null ; then
493                         test_ok_
494                 else
495                         testname=$this_test.$test_count
496                         basename1=`basename "$file1"`
497                         basename2=`basename "$file2"`
498                         cp "$file1" "$testname.$basename1"
499                         cp "$file2" "$testname.$basename2"
500                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
501                 fi
502     fi
503 }
504
505 # Like test_expect_equal, but arguments are JSON expressions to be
506 # canonicalized before diff'ing.  If an argument cannot be parsed, it
507 # is used unchanged so that there's something to diff against.
508 test_expect_equal_json () {
509     # The test suite forces LC_ALL=C, but this causes Python 3 to
510     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
511     # override Python's stdio encoding defaults.
512     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
513     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
514         || echo "$1")
515     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
516         || echo "$2")
517     shift 2
518     test_expect_equal "$output" "$expected" "$@"
519 }
520
521 # Sort the top-level list of JSON data from stdin.
522 test_sort_json () {
523     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
524         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
525 }
526
527 # test for json objects:
528 # read the source of test/json_check_nodes.py (or the output when
529 # invoking it without arguments) for an explanation of the syntax.
530 test_json_nodes () {
531         exec 1>&6 2>&7          # Restore stdout and stderr
532         if [ -z "$inside_subtest" ]; then
533                 error "bug in the test script: test_json_eval without test_begin_subtest"
534         fi
535         inside_subtest=
536         test "$#" > 0 ||
537             error "bug in the test script: test_json_nodes needs at least 1 parameter"
538
539         if ! test_skip "$test_subtest_name"
540         then
541             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON "$TEST_DIRECTORY"/json_check_nodes.py "$@")
542                 if [ "$?" = 0 ]
543                 then
544                         test_ok_
545                 else
546                         test_failure_ "$output"
547                 fi
548         fi
549 }
550
551 test_emacs_expect_t () {
552         test "$#" = 1 ||
553         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
554         if [ -z "$inside_subtest" ]; then
555                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
556         fi
557
558         # Run the test.
559         if ! test_skip "$test_subtest_name"
560         then
561                 test_emacs "(notmuch-test-run $1)" >/dev/null
562
563                 # Restore state after the test.
564                 exec 1>&6 2>&7          # Restore stdout and stderr
565                 inside_subtest=
566
567                 # Report success/failure.
568                 result=$(cat OUTPUT)
569                 if [ "$result" = t ]
570                 then
571                         test_ok_
572                 else
573                         test_failure_ "${result}"
574                 fi
575         else
576                 # Restore state after the (non) test.
577                 exec 1>&6 2>&7          # Restore stdout and stderr
578                 inside_subtest=
579         fi
580 }
581
582 NOTMUCH_NEW ()
583 {
584     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
585 }
586
587 NOTMUCH_DUMP_TAGS ()
588 {
589     # this relies on the default format being batch-tag, otherwise some tests will break
590     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
591 }
592
593 notmuch_drop_mail_headers ()
594 {
595     $NOTMUCH_PYTHON -c '
596 import email, sys
597 msg = email.message_from_file(sys.stdin)
598 for hdr in sys.argv[1:]: del msg[hdr]
599 print(msg.as_string(False))
600 ' "$@"
601 }
602
603 notmuch_search_sanitize ()
604 {
605     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
606 }
607
608 notmuch_search_files_sanitize ()
609 {
610     notmuch_dir_sanitize
611 }
612
613 notmuch_dir_sanitize ()
614 {
615     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
616 }
617
618 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
619 notmuch_show_sanitize ()
620 {
621     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
622 }
623 notmuch_show_sanitize_all ()
624 {
625     sed \
626         -e 's| filename:.*| filename:XXXXX|' \
627         -e 's| id:[^ ]* | id:XXXXX |' | \
628         notmuch_date_sanitize
629 }
630
631 notmuch_json_show_sanitize ()
632 {
633     sed \
634         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
635         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
636         -e 's|"filename": "signature.asc",||g' \
637         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
638         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
639         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
640 }
641
642 notmuch_emacs_error_sanitize ()
643 {
644     local command=$1
645     shift
646     for file in "$@"; do
647         echo "=== $file ==="
648         cat "$file"
649     done | sed  \
650         -e 's/^\[.*\]$/[XXX]/' \
651         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
652 }
653
654 notmuch_date_sanitize ()
655 {
656     sed \
657         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
658 }
659
660 notmuch_uuid_sanitize ()
661 {
662     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
663 }
664
665 notmuch_built_with_sanitize ()
666 {
667     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
668 }
669
670 notmuch_config_sanitize ()
671 {
672     notmuch_dir_sanitize | notmuch_built_with_sanitize
673 }
674
675 notmuch_show_part ()
676 {
677     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
678 }
679
680 # End of notmuch helper functions
681
682 # Use test_set_prereq to tell that a particular prerequisite is available.
683 #
684 # The prerequisite can later be checked for by using test_have_prereq.
685 #
686 # The single parameter is the prerequisite tag (a simple word, in all
687 # capital letters by convention).
688
689 test_set_prereq () {
690         satisfied="$satisfied$1 "
691 }
692 satisfied=" "
693
694 test_have_prereq () {
695         case $satisfied in
696         *" $1 "*)
697                 : yes, have it ;;
698         *)
699                 ! : nope ;;
700         esac
701 }
702
703 declare -A test_missing_external_prereq_
704 declare -A test_subtest_missing_external_prereq_
705
706 # declare prerequisite for the given external binary
707 test_declare_external_prereq () {
708         binary="$1"
709         test "$#" = 2 && name=$2 || name="$binary(1)"
710
711         if ! hash $binary 2>/dev/null; then
712                 test_missing_external_prereq_["${binary}"]=t
713                 eval "
714 $binary () {
715         test_subtest_missing_external_prereq_[\"${name}\"]=t
716         false
717 }"
718         fi
719 }
720
721 # Explicitly require external prerequisite.  Useful when binary is
722 # called indirectly (e.g. from emacs).
723 # Returns success if dependency is available, failure otherwise.
724 test_require_external_prereq () {
725         binary="$1"
726         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
727                 # dependency is missing, call the replacement function to note it
728                 eval "$binary"
729         else
730                 true
731         fi
732 }
733
734 # You are not expected to call test_ok_ and test_failure_ directly, use
735 # the text_expect_* functions instead.
736
737 test_ok_ () {
738         if test "$test_subtest_known_broken_" = "t"; then
739                 test_known_broken_ok_
740                 return
741         fi
742         test_success=$(($test_success + 1))
743         if test -n "$NOTMUCH_TEST_QUIET"; then
744                 return 0
745         fi
746         say_color pass "%-6s" "PASS"
747         echo " $test_subtest_name"
748 }
749
750 test_failure_ () {
751         print_test_description
752         if test "$test_subtest_known_broken_" = "t"; then
753                 test_known_broken_failure_ "$@"
754                 return
755         fi
756         test_failure=$(($test_failure + 1))
757         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
758         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
759         return 1
760 }
761
762 test_failure_message_ () {
763         say_color error "%-6s" "$1"
764         echo " $2"
765         shift 2
766         if [ "$#" != "0" ]; then
767                 echo "$@" | sed -e 's/^/        /'
768         fi
769         if test "$verbose" != "t"; then cat test.output; fi
770 }
771
772 test_known_broken_ok_ () {
773         test_reset_state_
774         test_fixed=$(($test_fixed+1))
775         say_color pass "%-6s" "FIXED"
776         echo " $test_subtest_name"
777 }
778
779 test_known_broken_failure_ () {
780         test_reset_state_
781         test_broken=$(($test_broken+1))
782         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
783                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
784         else
785                 test_failure_message_ "BROKEN" "$test_subtest_name"
786         fi
787         return 1
788 }
789
790 test_debug () {
791         test "$debug" = "" || eval "$1"
792 }
793
794 test_run_ () {
795         test_cleanup=:
796         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
797         eval >&3 2>&4 "$1"
798         eval_ret=$?
799         eval >&3 2>&4 "$test_cleanup"
800         return 0
801 }
802
803 test_skip () {
804         test_count=$(($test_count+1))
805         to_skip=
806         for skp in $NOTMUCH_SKIP_TESTS
807         do
808                 case $this_test.$test_count in
809                 $skp)
810                         to_skip=t
811                         break
812                 esac
813                 case $this_test_bare.$test_count in
814                 $skp)
815                         to_skip=t
816                         break
817                 esac
818         done
819         case "$to_skip" in
820         t)
821                 test_report_skip_ "$@"
822                 ;;
823         *)
824                 test_check_missing_external_prereqs_ "$@"
825                 ;;
826         esac
827 }
828
829 test_check_missing_external_prereqs_ () {
830         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
831                 say_color skip >&1 "missing prerequisites: "
832                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
833                 test_report_skip_ "$@"
834         else
835                 false
836         fi
837 }
838
839 test_report_skip_ () {
840         test_reset_state_
841         say_color skip >&3 "skipping test:"
842         echo " $@" >&3
843         say_color skip "%-6s" "SKIP"
844         echo " $1"
845 }
846
847 test_subtest_known_broken () {
848         test_subtest_known_broken_=t
849 }
850
851 test_expect_success () {
852         exec 1>&6 2>&7          # Restore stdout and stderr
853         if [ -z "$inside_subtest" ]; then
854                 error "bug in the test script: test_expect_success without test_begin_subtest"
855         fi
856         inside_subtest=
857         test "$#" = 1 ||
858         error "bug in the test script: not 1 parameters to test_expect_success"
859
860         if ! test_skip "$test_subtest_name"
861         then
862                 test_run_ "$1"
863                 run_ret="$?"
864                 # test_run_ may update missing external prerequisites
865                 test_check_missing_external_prereqs_ "$@" ||
866                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
867                 then
868                         test_ok_
869                 else
870                         test_failure_ "$1"
871                 fi
872         fi
873 }
874
875 test_expect_code () {
876         exec 1>&6 2>&7          # Restore stdout and stderr
877         if [ -z "$inside_subtest" ]; then
878                 error "bug in the test script: test_expect_code without test_begin_subtest"
879         fi
880         inside_subtest=
881         test "$#" = 2 ||
882         error "bug in the test script: not 2 parameters to test_expect_code"
883
884         if ! test_skip "$test_subtest_name"
885         then
886                 test_run_ "$2"
887                 run_ret="$?"
888                 # test_run_ may update missing external prerequisites,
889                 test_check_missing_external_prereqs_ "$@" ||
890                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
891                 then
892                         test_ok_
893                 else
894                         test_failure_ "exit code $eval_ret, expected $1" "$2"
895                 fi
896         fi
897 }
898
899 # This is not among top-level (test_expect_success)
900 # but is a prefix that can be used in the test script, like:
901 #
902 #       test_expect_success 'complain and die' '
903 #           do something &&
904 #           do something else &&
905 #           test_must_fail git checkout ../outerspace
906 #       '
907 #
908 # Writing this as "! git checkout ../outerspace" is wrong, because
909 # the failure could be due to a segv.  We want a controlled failure.
910
911 test_must_fail () {
912         "$@"
913         test $? -gt 0 -a $? -le 129 -o $? -gt 192
914 }
915
916 # test_cmp is a helper function to compare actual and expected output.
917 # You can use it like:
918 #
919 #       test_expect_success 'foo works' '
920 #               echo expected >expected &&
921 #               foo >actual &&
922 #               test_cmp expected actual
923 #       '
924 #
925 # This could be written as either "cmp" or "diff -u", but:
926 # - cmp's output is not nearly as easy to read as diff -u
927 # - not all diff versions understand "-u"
928
929 test_cmp() {
930         $GIT_TEST_CMP "$@"
931 }
932
933 # This function can be used to schedule some commands to be run
934 # unconditionally at the end of the test to restore sanity:
935 #
936 #       test_expect_success 'test core.capslock' '
937 #               git config core.capslock true &&
938 #               test_when_finished "git config --unset core.capslock" &&
939 #               hello world
940 #       '
941 #
942 # That would be roughly equivalent to
943 #
944 #       test_expect_success 'test core.capslock' '
945 #               git config core.capslock true &&
946 #               hello world
947 #               git config --unset core.capslock
948 #       '
949 #
950 # except that the greeting and config --unset must both succeed for
951 # the test to pass.
952
953 test_when_finished () {
954         test_cleanup="{ $*
955                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
956 }
957
958 test_done () {
959         GIT_EXIT_OK=t
960         test_results_dir="$TEST_DIRECTORY/test-results"
961         mkdir -p "$test_results_dir"
962         test_results_path="$test_results_dir/$this_test"
963
964         echo "total $test_count" >> $test_results_path
965         echo "success $test_success" >> $test_results_path
966         echo "fixed $test_fixed" >> $test_results_path
967         echo "broken $test_broken" >> $test_results_path
968         echo "failed $test_failure" >> $test_results_path
969         echo "" >> $test_results_path
970
971         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
972
973         if [ "$test_failure" = "0" ]; then
974             if [ "$test_broken" = "0" ]; then
975                 rm -rf "$remove_tmp"
976             fi
977             exit 0
978         else
979             exit 1
980         fi
981 }
982
983 emacs_generate_script () {
984         # Construct a little test script here for the benefit of the user,
985         # (who can easily run "run_emacs" to get the same emacs environment
986         # for investigating any failures).
987         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
988 #!/bin/sh
989 export PATH=$PATH
990 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
991
992 # Here's what we are using here:
993 #
994 # --quick              Use minimal customization. This implies --no-init-file,
995 #                      --no-site-file and (emacs 24) --no-site-lisp
996 #
997 # --directory           Ensure that the local elisp sources are found
998 #
999 # --load                Force loading of notmuch.el and test-lib.el
1000
1001 exec ${TEST_EMACS} --quick \
1002         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
1003         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
1004         "\$@"
1005 EOF
1006         chmod a+x "$TMP_DIRECTORY/run_emacs"
1007 }
1008
1009 test_emacs () {
1010         # test dependencies beforehand to avoid the waiting loop below
1011         missing_dependencies=
1012         test_require_external_prereq dtach || missing_dependencies=1
1013         test_require_external_prereq emacs || missing_dependencies=1
1014         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1015         test -z "$missing_dependencies" || return
1016
1017         if [ -z "$EMACS_SERVER" ]; then
1018                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1019                 if [ -f "$emacs_tests" ]; then
1020                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1021                 else
1022                         load_emacs_tests=
1023                 fi
1024                 server_name="notmuch-test-suite-$$"
1025                 # start a detached session with an emacs server
1026                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1027                 # or unknown) is given to dtach which assumes a minimally
1028                 # VT100-compatible terminal -- and emacs inherits that
1029                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1030                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1031                                 --no-window-system \
1032                                 $load_emacs_tests \
1033                                 --eval '(setq server-name \"$server_name\")' \
1034                                 --eval '(server-start)' \
1035                                 --eval '(orphan-watchdog $$)'" || return
1036                 EMACS_SERVER="$server_name"
1037                 # wait until the emacs server is up
1038                 until test_emacs '()' >/dev/null 2>/dev/null; do
1039                         sleep 1
1040                 done
1041         fi
1042
1043         # Clear test-output output file.  Most Emacs tests end with a
1044         # call to (test-output).  If the test code fails with an
1045         # exception before this call, the output file won't get
1046         # updated.  Since we don't want to compare against an output
1047         # file from another test, so start out with an empty file.
1048         rm -f OUTPUT
1049         touch OUTPUT
1050
1051         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1052 }
1053
1054 test_python() {
1055     # Note: if there is need to print debug information from python program,
1056     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1057     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1058         $NOTMUCH_PYTHON -B - > OUTPUT
1059 }
1060
1061 test_ruby() {
1062     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1063 }
1064
1065 test_C () {
1066     exec_file="test${test_count}"
1067     test_file="${exec_file}.c"
1068     cat > ${test_file}
1069     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1070     echo "== stdout ==" > OUTPUT.stdout
1071     echo "== stderr ==" > OUTPUT.stderr
1072     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1073     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1074 }
1075
1076 make_shim () {
1077     base_name="$1"
1078     test_file="${base_name}.c"
1079     shim_file="${base_name}.so"
1080     cat > ${test_file}
1081     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1082 }
1083
1084 notmuch_with_shim () {
1085     base_name="$1"
1086     shift
1087     shim_file="${base_name}.so"
1088     LD_PRELOAD=./${shim_file}${LD_PRELOAD:+:$LD_PRELOAD} notmuch-shared "$@"
1089 }
1090
1091 # Creates a script that counts how much time it is executed and calls
1092 # notmuch.  $notmuch_counter_command is set to the path to the
1093 # generated script.  Use notmuch_counter_value() function to get the
1094 # current counter value.
1095 notmuch_counter_reset () {
1096         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1097         if [ ! -x "$notmuch_counter_command" ]; then
1098                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1099                 cat >"$notmuch_counter_command" <<EOF || return
1100 #!/bin/sh
1101
1102 read count < "$notmuch_counter_state_path"
1103 echo \$((count + 1)) > "$notmuch_counter_state_path"
1104
1105 exec notmuch "\$@"
1106 EOF
1107                 chmod +x "$notmuch_counter_command" || return
1108         fi
1109
1110         echo 0 > "$notmuch_counter_state_path"
1111 }
1112
1113 # Returns the current notmuch counter value.
1114 notmuch_counter_value () {
1115         if [ -r "$notmuch_counter_state_path" ]; then
1116                 read count < "$notmuch_counter_state_path"
1117         else
1118                 count=0
1119         fi
1120         echo $count
1121 }
1122
1123 test_reset_state_ () {
1124         test -z "$test_init_done_" && test_init_
1125
1126         test_subtest_known_broken_=
1127         test_subtest_missing_external_prereq_=()
1128 }
1129
1130 # called once before the first subtest
1131 test_init_ () {
1132         test_init_done_=t
1133
1134         # skip all tests if there were external prerequisites missing during init
1135         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1136 }
1137
1138
1139 # Where to run the tests
1140 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1141
1142 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1143
1144 emacs_generate_script
1145
1146
1147 # Use -P to resolve symlinks in our working directory so that the cwd
1148 # in subprocesses like git equals our $PWD (for pathname comparisons).
1149 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1150
1151 if test "$verbose" = "t"
1152 then
1153         exec 4>&2 3>&1
1154 else
1155         exec 4>test.output 3>&4
1156 fi
1157
1158 for skp in $NOTMUCH_SKIP_TESTS
1159 do
1160         to_skip=
1161         for skp in $NOTMUCH_SKIP_TESTS
1162         do
1163                 case "$this_test" in
1164                 $skp)
1165                         to_skip=t
1166                         break
1167                 esac
1168                 case "$this_test_bare" in
1169                 $skp)
1170                         to_skip=t
1171                         break
1172                 esac
1173         done
1174         case "$to_skip" in
1175         t)
1176                 say_color skip >&3 "skipping test $this_test altogether"
1177                 say_color skip "skip all tests in $this_test"
1178                 test_done
1179         esac
1180 done
1181
1182 # Provide an implementation of the 'yes' utility
1183 yes () {
1184         if test $# = 0
1185         then
1186                 y=y
1187         else
1188                 y="$*"
1189         fi
1190
1191         while echo "$y"
1192         do
1193                 :
1194         done
1195 }
1196
1197 # Fix some commands on Windows
1198 case $(uname -s) in
1199 *MINGW*)
1200         # Windows has its own (incompatible) sort and find
1201         sort () {
1202                 /usr/bin/sort "$@"
1203         }
1204         find () {
1205                 /usr/bin/find "$@"
1206         }
1207         sum () {
1208                 md5sum "$@"
1209         }
1210         # git sees Windows-style pwd
1211         pwd () {
1212                 builtin pwd -W
1213         }
1214         # no POSIX permissions
1215         # backslashes in pathspec are converted to '/'
1216         # exec does not inherit the PID
1217         ;;
1218 *)
1219         test_set_prereq POSIXPERM
1220         test_set_prereq BSLASHPSPEC
1221         test_set_prereq EXECKEEPSPID
1222         ;;
1223 esac
1224
1225 test -z "$NO_PERL" && test_set_prereq PERL
1226 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1227
1228 # test whether the filesystem supports symbolic links
1229 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1230 rm -f y
1231
1232 # convert variable from configure to more convenient form
1233 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1234     glass)
1235         db_ending=glass
1236     ;;
1237     chert)
1238         db_ending=DB
1239     ;;
1240     *)
1241         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1242 esac
1243 # declare prerequisites for external binaries used in tests
1244 test_declare_external_prereq dtach
1245 test_declare_external_prereq emacs
1246 test_declare_external_prereq ${TEST_EMACSCLIENT}
1247 test_declare_external_prereq ${TEST_GDB}
1248 test_declare_external_prereq gpg
1249 test_declare_external_prereq openssl
1250 test_declare_external_prereq gpgsm
1251 test_declare_external_prereq ${NOTMUCH_PYTHON}